/*
*  Licensed Materials - Property of IBM
*  5725-G92 (C) Copyright IBM Corp. 2006, 2013. All Rights Reserved.
*  US Government Users Restricted Rights - Use, duplication or
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/// /////////////////////
// Challenge Handler
// /////////////////////
var challengeHandler1 = WL.Client.createChallengeHandler("realm1");

challengeHandler1.isInitialized = false;
challengeHandler1.isCustomResponse = function(transport) {
    if (typeof Authenticator == "undefined") {
        return false;
    }

    if (!this.isInitialized) {
        this.isInitialized = true;
        Authenticator.init();
    }

    var isLoginFormResponse = Authenticator.isLoginFormResponse(transport);
    if (isLoginFormResponse) {
        Authenticator.onBeforeLogin(transport, null, challengeHandler1.submitLoginForm);
        Authenticator.onShowLogin();
    } else {
        Authenticator.onHideLogin();
    }
    return isLoginFormResponse;

};

challengeHandler1.submitLoginForm = function(reqURL, params) {
    var headers = {};
    WL.Client.submitLoginForm(reqURL, params, headers, challengeHandler1.submitLoginFormCallback);
};

challengeHandler1.submitLoginFormCallback = function(transport) {
    var isLoginFormResponse = challengeHandler1.isCustomResponse(transport);
    if (!isLoginFormResponse) {
        challengeHandler1.submitSuccess();
    }
};


window.$ = WLJQ;

var Authenticator = function() {

	function AuthStep1SubmitClicked() {
		var username = $("#AuthUsername").val();
		var password = $("#AuthPassword").val();

		var invocationData = {
			adapter : "DoubleStepAuthAdapter",
			procedure : "submitAuthStep1",
			parameters : [ username, password ]
		};

		WL.Client.invokeProcedure(invocationData, {});
	}

	function AuthStep2SubmitClicked() {
		var answer = $("#AuthAnswer").val();

		var invocationData = {
			adapter : "DoubleStepAuthAdapter",
			procedure : "submitAuthStep2",
			parameters : [ answer ]
		};

		WL.Client.invokeProcedure(invocationData, {});
	}

	return {

		init : function() {
			$("#AuthStep1Submit").bind('click', AuthStep1SubmitClicked);
			$("#AuthStep2Submit").bind('click', AuthStep2SubmitClicked);
		},

		isLoginFormResponse : function(response) {
			if (!response || !response.responseJSON
					|| response.responseText === null) {
				return false;
			}
			return response.responseJSON.authRequired;
		},

		onBeforeLogin : function(response, username, onSubmit, onCancel) {
			$("#AuthStep1Div").hide();
			$("#AuthStep2Div").hide();
			$("#AuthInfo").empty();

			switch (response.responseJSON.authStep) {
				case 1:
					$("#AuthStep1Div").show();
					break;
				case 2:
					$("#AuthStep2Div").show();
					$("#AuthQuestion").html(response.responseJSON.question);
					break;
			}

			if (response.responseJSON.errorMessage)
				$("#AuthInfo").html(new Date() + " :: "	+ response.responseJSON.errorMessage);

		},

		onShowLogin : function() {
			$("#AppDiv").hide();
			$("#AuthDiv").show();
		},

		onHideLogin : function() {
			$("#AppDiv").show();
			$("#AuthDiv").hide();
		}
	};
}();
